<a href='https://github.com/angular/angular.js/edit/master/src/ng/sce.js?message=docs($sce)%3A%20describe%20your%20change...#L404' class='improve-docs btn btn-primary'><i class="glyphicon glyphicon-edit">&nbsp;</i>Improve this Doc</a>



<a href='https://github.com/angular/angular.js/tree/master/src/ng/sce.js#L404' class='view-source pull-right btn btn-primary'>
  <i class="glyphicon glyphicon-zoom-in">&nbsp;</i>View Source
</a>


<header class="api-profile-header">
  <h1 class="api-profile-header-heading">$sce</h1>
  <ol class="api-profile-header-structure naked-list step-list">
    
  <li>
    <a href="api/ng/provider/$sceProvider">- $sceProvider</a>
  </li>

    <li>
      - service in module <a href="api/ng">ng</a>
    </li>
  </ol>
</header>



<div class="api-profile-description">
  <p><code>$sce</code> is a service that provides Strict Contextual Escaping services to AngularJS.</p>
<h1 id="strict-contextual-escaping">Strict Contextual Escaping</h1>
<p>Strict Contextual Escaping (SCE) is a mode in which AngularJS requires bindings in certain
contexts to result in a value that is marked as safe to use for that context.  One example of
such a context is binding arbitrary html controlled by the user via <code>ng-bind-html</code>.  We refer
to these contexts as privileged or SCE contexts.</p>
<p>As of version 1.2, Angular ships with SCE enabled by default.</p>
<p>Note:  When enabled (the default), IE<11 in quirks mode is not supported.  In this mode, IE<11 allow
one to execute arbitrary javascript by the use of the expression() syntax.  Refer
<http://blogs.msdn.com/b/ie/archive/2008/10/16/ending-expressions.aspx> to learn more about them.
You can ensure your document is in standards mode and not quirks mode by adding <code>&lt;!doctype html&gt;</code>
to the top of your HTML document.</p>
<p>SCE assists in writing code in way that (a) is secure by default and (b) makes auditing for
security vulnerabilities such as XSS, clickjacking, etc. a lot easier.</p>
<p>Here&#39;s an example of a binding in a privileged context:</p>
<pre><code>&lt;input ng-model=&quot;userHtml&quot; aria-label=&quot;User input&quot;&gt;
&lt;div ng-bind-html=&quot;userHtml&quot;&gt;&lt;/div&gt;
</code></pre>
<p>Notice that <code>ng-bind-html</code> is bound to <code>userHtml</code> controlled by the user.  With SCE
disabled, this application allows the user to render arbitrary HTML into the DIV.
In a more realistic example, one may be rendering user comments, blog articles, etc. via
bindings.  (HTML is just one example of a context where rendering user controlled input creates
security vulnerabilities.)</p>
<p>For the case of HTML, you might use a library, either on the client side, or on the server side,
to sanitize unsafe HTML before binding to the value and rendering it in the document.</p>
<p>How would you ensure that every place that used these types of bindings was bound to a value that
was sanitized by your library (or returned as safe for rendering by your server?)  How can you
ensure that you didn&#39;t accidentally delete the line that sanitized the value, or renamed some
properties/fields and forgot to update the binding to the sanitized value?</p>
<p>To be secure by default, you want to ensure that any such bindings are disallowed unless you can
determine that something explicitly says it&#39;s safe to use a value for binding in that
context.  You can then audit your code (a simple grep would do) to ensure that this is only done
for those values that you can easily tell are safe - because they were received from your server,
sanitized by your library, etc.  You can organize your codebase to help with this - perhaps
allowing only the files in a specific directory to do this.  Ensuring that the internal API
exposed by that code doesn&#39;t markup arbitrary values as safe then becomes a more manageable task.</p>
<p>In the case of AngularJS&#39; SCE service, one uses <a href="api/ng/service/$sce#trustAs">$sce.trustAs</a>
(and shorthand methods such as <a href="api/ng/service/$sce#trustAsHtml">$sce.trustAsHtml</a>, etc.) to
obtain values that will be accepted by SCE / privileged contexts.</p>
<h2 id="how-does-it-work-">How does it work?</h2>
<p>In privileged contexts, directives and code will bind to the result of <a href="api/ng/service/$sce#getTrusted">$sce.getTrusted(context, value)</a> rather than to the value directly.  Directives use <a href="api/ng/service/$sce#parseAs">$sce.parseAs</a> rather than <code>$parse</code> to watch attribute bindings, which performs the
<a href="api/ng/service/$sce#getTrusted">$sce.getTrusted</a> behind the scenes on non-constant literals.</p>
<p>As an example, <a href="api/ng/directive/ngBindHtml">ngBindHtml</a> uses <a href="api/ng/service/$sce#parseAsHtml">$sce.parseAsHtml(binding expression)</a>.  Here&#39;s the actual code (slightly
simplified):</p>
<pre><code>var ngBindHtmlDirective = [&#39;$sce&#39;, function($sce) {
  return function(scope, element, attr) {
    scope.$watch($sce.parseAsHtml(attr.ngBindHtml), function(value) {
      element.html(value || &#39;&#39;);
    });
  };
}];
</code></pre>
<h2 id="impact-on-loading-templates">Impact on loading templates</h2>
<p>This applies both to the <a href="api/ng/directive/ngInclude"><code>ng-include</code></a> directive as well as
<code>templateUrl</code>&#39;s specified by <a href="guide/directive">directives</a>.</p>
<p>By default, Angular only loads templates from the same domain and protocol as the application
document.  This is done by calling <a href="api/ng/service/$sce#getTrustedResourceUrl">$sce.getTrustedResourceUrl</a> on the template URL.  To load templates from other domains and/or
protocols, you may either <a href="api/ng/provider/$sceDelegateProvider#resourceUrlWhitelist">whitelist
them</a> or <a href="api/ng/service/$sce#trustAsResourceUrl">wrap it</a> into a trusted value.</p>
<p><em>Please note</em>:
The browser&#39;s
<a href="https://code.google.com/p/browsersec/wiki/Part2#Same-origin_policy_for_XMLHttpRequest">Same Origin Policy</a>
and <a href="http://www.w3.org/TR/cors/">Cross-Origin Resource Sharing (CORS)</a>
policy apply in addition to this and may further restrict whether the template is successfully
loaded.  This means that without the right CORS policy, loading templates from a different domain
won&#39;t work on all browsers.  Also, loading templates from <code>file://</code> URL does not work on some
browsers.</p>
<h2 id="this-feels-like-too-much-overhead">This feels like too much overhead</h2>
<p>It&#39;s important to remember that SCE only applies to interpolation expressions.</p>
<p>If your expressions are constant literals, they&#39;re automatically trusted and you don&#39;t need to
call <code>$sce.trustAs</code> on them (remember to include the <code>ngSanitize</code> module) (e.g.
<code>&lt;div ng-bind-html=&quot;&#39;&lt;b&gt;implicitly trusted&lt;/b&gt;&#39;&quot;&gt;&lt;/div&gt;</code>) just works.</p>
<p>Additionally, <code>a[href]</code> and <code>img[src]</code> automatically sanitize their URLs and do not pass them
through <a href="api/ng/service/$sce#getTrusted">$sce.getTrusted</a>.  SCE doesn&#39;t play a role here.</p>
<p>The included <a href="api/ng/service/$sceDelegate">$sceDelegate</a> comes with sane defaults to allow you to load
templates in <code>ng-include</code> from your application&#39;s domain without having to even know about SCE.
It blocks loading templates from other domains or loading templates over http from an https
served document.  You can change these by setting your own custom <a href="api/ng/provider/$sceDelegateProvider#resourceUrlWhitelist">whitelists</a> and <a href="api/ng/provider/$sceDelegateProvider#resourceUrlBlacklist">blacklists</a> for matching such URLs.</p>
<p>This significantly reduces the overhead.  It is far easier to pay the small overhead and have an
application that&#39;s secure and can be audited to verify that with much more ease than bolting
security onto an application later.</p>
<p><a name="contexts"></a></p>
<h2 id="what-trusted-context-types-are-supported-">What trusted context types are supported?</h2>
<table>
<thead>
<tr>
<th>Context</th>
<th>Notes</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>$sce.HTML</code></td>
<td>For HTML that&#39;s safe to source into the application.  The <a href="api/ng/directive/ngBindHtml">ngBindHtml</a> directive uses this context for bindings. If an unsafe value is encountered and the <a href="api/ngSanitize">$sanitize</a> module is present this will sanitize the value instead of throwing an error.</td>
</tr>
<tr>
<td><code>$sce.CSS</code></td>
<td>For CSS that&#39;s safe to source into the application.  Currently unused.  Feel free to use it in your own directives.</td>
</tr>
<tr>
<td><code>$sce.URL</code></td>
<td>For URLs that are safe to follow as links.  Currently unused (<code>&lt;a href=</code> and <code>&lt;img src=</code> sanitize their urls and don&#39;t constitute an SCE context.</td>
</tr>
<tr>
<td><code>$sce.RESOURCE_URL</code></td>
<td>For URLs that are not only safe to follow as links, but whose contents are also safe to include in your application.  Examples include <code>ng-include</code>, <code>src</code> / <code>ngSrc</code> bindings for tags other than <code>IMG</code> (e.g. <code>IFRAME</code>, <code>OBJECT</code>, etc.)  <br><br>Note that <code>$sce.RESOURCE_URL</code> makes a stronger statement about the URL than <code>$sce.URL</code> does and therefore contexts requiring values trusted for <code>$sce.RESOURCE_URL</code> can be used anywhere that values trusted for <code>$sce.URL</code> are required.</td>
</tr>
<tr>
<td><code>$sce.JS</code></td>
<td>For JavaScript that is safe to execute in your application&#39;s context.  Currently unused.  Feel free to use it in your own directives.</td>
</tr>
</tbody>
</table>
<h2 id="format-of-items-in-link-ng-scedelegateprovider-resourceurlwhitelist-resourceurlwhitelist-link-ng-scedelegateprovider-resourceurlblacklist-blacklist-a-name-resourceurlpatternitem-a-">Format of items in <a href="api/ng/provider/$sceDelegateProvider#resourceUrlWhitelist">resourceUrlWhitelist</a>/<a href="api/ng/provider/$sceDelegateProvider#resourceUrlBlacklist">Blacklist</a> <a name="resourceUrlPatternItem"></a></h2>
<p> Each element in these arrays must be one of the following:</p>
<ul>
<li><strong>&#39;self&#39;</strong><ul>
<li>The special <strong>string</strong>, <code>&#39;self&#39;</code>, can be used to match against all URLs of the <strong>same
domain</strong> as the application document using the <strong>same protocol</strong>.</li>
</ul>
</li>
<li><strong>String</strong> (except the special value <code>&#39;self&#39;</code>)<ul>
<li>The string is matched against the full <em>normalized / absolute URL</em> of the resource
being tested (substring matches are not good enough.)</li>
<li>There are exactly <strong>two wildcard sequences</strong> - <code>*</code> and <code>**</code>.  All other characters
match themselves.</li>
<li><code>*</code>: matches zero or more occurrences of any character other than one of the following 6
characters: &#39;<code>:</code>&#39;, &#39;<code>/</code>&#39;, &#39;<code>.</code>&#39;, &#39;<code>?</code>&#39;, &#39;<code>&amp;</code>&#39; and &#39;<code>;</code>&#39;.  It&#39;s a useful wildcard for use
in a whitelist.</li>
<li><code>**</code>: matches zero or more occurrences of <em>any</em> character.  As such, it&#39;s not
appropriate for use in a scheme, domain, etc. as it would match too much.  (e.g.
<a href="http://**.example.com/">http://**.example.com/</a> would match <a href="http://evil.com/?ignore=.example.com/">http://evil.com/?ignore=.example.com/</a> and that might
not have been the intention.)  Its usage at the very end of the path is ok.  (e.g.
<a href="http://foo.example.com/templates/**">http://foo.example.com/templates/**</a>).</li>
</ul>
</li>
<li><strong>RegExp</strong> (<em>see caveat below</em>)<ul>
<li><em>Caveat</em>:  While regular expressions are powerful and offer great flexibility,  their syntax
(and all the inevitable escaping) makes them <em>harder to maintain</em>.  It&#39;s easy to
accidentally introduce a bug when one updates a complex expression (imho, all regexes should
have good test coverage).  For instance, the use of <code>.</code> in the regex is correct only in a
small number of cases.  A <code>.</code> character in the regex used when matching the scheme or a
subdomain could be matched against a <code>:</code> or literal <code>.</code> that was likely not intended.   It
is highly recommended to use the string patterns and only fall back to regular expressions
as a last resort.</li>
<li>The regular expression must be an instance of RegExp (i.e. not a string.)  It is
matched against the <strong>entire</strong> <em>normalized / absolute URL</em> of the resource being tested
(even when the RegExp did not have the <code>^</code> and <code>$</code> codes.)  In addition, any flags
present on the RegExp (such as multiline, global, ignoreCase) are ignored.</li>
<li>If you are generating your JavaScript from some other templating engine (not
recommended, e.g. in issue <a href="https://github.com/angular/angular.js/issues/4006">#4006</a>),
remember to escape your regular expression (and be aware that you might need more than
one level of escaping depending on your templating engine and the way you interpolated
the value.)  Do make use of your platform&#39;s escaping mechanism as it might be good
enough before coding your own.  E.g. Ruby has
<a href="http://www.ruby-doc.org/core-2.0.0/Regexp.html#method-c-escape">Regexp.escape(str)</a>
and Python has <a href="http://docs.python.org/library/re.html#re.escape">re.escape</a>.
Javascript lacks a similar built in function for escaping.  Take a look at Google
Closure library&#39;s <a href="http://docs.closure-library.googlecode.com/git/closure_goog_string_string.js.source.html#line962">goog.string.regExpEscape(s)</a>.</li>
</ul>
</li>
</ul>
<p>Refer <a href="api/ng/provider/$sceDelegateProvider">$sceDelegateProvider</a> for an example.</p>
<h2 id="show-me-an-example-using-sce-">Show me an example using SCE.</h2>
<p>

<div>
  <plnkr-opener example-path="examples/example-example111"></plnkr-opener>

  <div class="runnable-example"
      path="examples/example-example111"
      module="mySceApp"
      deps="angular-sanitize.js">

  
    <div class="runnable-example-file" 
      name="index.html"
      language="html"
      type="html">
      <pre><code>&lt;div ng-controller=&quot;AppController as myCtrl&quot;&gt;&#10;  &lt;i ng-bind-html=&quot;myCtrl.explicitlyTrustedHtml&quot; id=&quot;explicitlyTrustedHtml&quot;&gt;&lt;/i&gt;&lt;br&gt;&lt;br&gt;&#10;  &lt;b&gt;User comments&lt;/b&gt;&lt;br&gt;&#10;  By default, HTML that isn&#39;t explicitly trusted (e.g. Alice&#39;s comment) is sanitized when&#10;  $sanitize is available.  If $sanitize isn&#39;t available, this results in an error instead of an&#10;  exploit.&#10;  &lt;div class=&quot;well&quot;&gt;&#10;    &lt;div ng-repeat=&quot;userComment in myCtrl.userComments&quot;&gt;&#10;      &lt;b&gt;{{userComment.name}}&lt;/b&gt;:&#10;      &lt;span ng-bind-html=&quot;userComment.htmlComment&quot; class=&quot;htmlComment&quot;&gt;&lt;/span&gt;&#10;      &lt;br&gt;&#10;    &lt;/div&gt;&#10;  &lt;/div&gt;&#10;&lt;/div&gt;</code></pre>
    </div>
  
    <div class="runnable-example-file" 
      name="script.js"
      language="js"
      type="js">
      <pre><code>angular.module(&#39;mySceApp&#39;, [&#39;ngSanitize&#39;])&#10;.controller(&#39;AppController&#39;, [&#39;$http&#39;, &#39;$templateCache&#39;, &#39;$sce&#39;,&#10;  function($http, $templateCache, $sce) {&#10;    var self = this;&#10;    $http.get(&quot;test_data.json&quot;, {cache: $templateCache}).success(function(userComments) {&#10;      self.userComments = userComments;&#10;    });&#10;    self.explicitlyTrustedHtml = $sce.trustAsHtml(&#10;        &#39;&lt;span onmouseover=&quot;this.textContent=&amp;quot;Explicitly trusted HTML bypasses &#39; +&#10;        &#39;sanitization.&amp;quot;&quot;&gt;Hover over this text.&lt;/span&gt;&#39;);&#10;  }]);</code></pre>
    </div>
  
    <div class="runnable-example-file" 
      name="test_data.json"
      language="json"
      type="json">
      <pre><code>[&#10;  { &quot;name&quot;: &quot;Alice&quot;,&#10;    &quot;htmlComment&quot;:&#10;        &quot;&lt;span onmouseover=&#39;this.textContent=\&quot;PWN3D!\&quot;&#39;&gt;Is &lt;i&gt;anyone&lt;/i&gt; reading this?&lt;/span&gt;&quot;&#10;  },&#10;  { &quot;name&quot;: &quot;Bob&quot;,&#10;    &quot;htmlComment&quot;: &quot;&lt;i&gt;Yes!&lt;/i&gt;  Am I the only other one?&quot;&#10;  }&#10;]</code></pre>
    </div>
  
    <div class="runnable-example-file" 
      name="protractor.js"
      type="protractor"
      language="js">
      <pre><code>describe(&#39;SCE doc demo&#39;, function() {&#10;  it(&#39;should sanitize untrusted values&#39;, function() {&#10;    expect(element.all(by.css(&#39;.htmlComment&#39;)).first().getInnerHtml())&#10;        .toBe(&#39;&lt;span&gt;Is &lt;i&gt;anyone&lt;/i&gt; reading this?&lt;/span&gt;&#39;);&#10;  });&#10;&#10;  it(&#39;should NOT sanitize explicitly trusted values&#39;, function() {&#10;    expect(element(by.id(&#39;explicitlyTrustedHtml&#39;)).getInnerHtml()).toBe(&#10;        &#39;&lt;span onmouseover=&quot;this.textContent=&amp;quot;Explicitly trusted HTML bypasses &#39; +&#10;        &#39;sanitization.&amp;quot;&quot;&gt;Hover over this text.&lt;/span&gt;&#39;);&#10;  });&#10;});</code></pre>
    </div>
  

    <iframe class="runnable-example-frame" src="examples/example-example111/index.html" name="example-example111"></iframe>
  </div>
</div>


</p>
<h2 id="can-i-disable-sce-completely-">Can I disable SCE completely?</h2>
<p>Yes, you can.  However, this is strongly discouraged.  SCE gives you a lot of security benefits
for little coding overhead.  It will be much harder to take an SCE disabled application and
either secure it on your own or enable SCE at a later stage.  It might make sense to disable SCE
for cases where you have a lot of existing code that was written before SCE was introduced and
you&#39;re migrating them a module at a time.</p>
<p>That said, here&#39;s how you can completely disable SCE:</p>
<pre><code>angular.module(&#39;myAppWithSceDisabledmyApp&#39;, []).config(function($sceProvider) {
  // Completely disable SCE.  For demonstration purposes only!
  // Do not use in new projects.
  $sceProvider.enabled(false);
});
</code></pre>

</div>




<div>
  

    

  <h2 id="usage">Usage</h2>
    
      <p><code>$sce();</code></p>


    

    
    
    

  
<h2>Methods</h2>
<ul class="methods">
  <li id="isEnabled">
    <h3><p><code>isEnabled();</code></p>

</h3>
    <div><p>Returns a boolean indicating if SCE is enabled.</p>
</div>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-boolean">Boolean</a></td>
    <td><p>true if SCE is enabled, false otherwise.  If you want to set the value, you
have to do it at module config time on <a href="api/ng/provider/$sceProvider">$sceProvider</a>.</p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="parseAs">
    <h3><p><code>parseAs(type, expression);</code></p>

</h3>
    <div><p>Converts Angular <a href="guide/expression">expression</a> into a function.  This is like <a href="api/ng/service/$parse">$parse</a> and is identical when the expression is a literal constant.  Otherwise, it
wraps the expression in a call to <a href="api/ng/service/$sce#getTrusted">$sce.getTrusted(<em>type</em>,
<em>result</em>)</a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        type
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>The kind of SCE context in which this result will be used.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        expression
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>String expression to compile.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-function">function(context, locals)</a></td>
    <td><p>a function which represents the compiled expression:</p>
<ul>
<li><code>context</code> – <code>{object}</code> – an object against which any expressions embedded in the strings
are evaluated against (typically a scope object).</li>
<li><code>locals</code> – <code>{object=}</code> – local variables context object, useful for overriding values in
<code>context</code>.</li>
</ul>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="trustAs">
    <h3><p><code>trustAs(type, value);</code></p>

</h3>
    <div><p>Delegates to <a href="api/ng/service/$sceDelegate#trustAs"><code>$sceDelegate.trustAs</code></a>.  As such,
returns an object that is trusted by angular for use in specified strict contextual
escaping contexts (such as ng-bind-html, ng-include, any src attribute
interpolation, any dom event binding attribute interpolation such as for onclick,  etc.)
that uses the provided value.  See * <a href="api/ng/service/$sce">$sce</a> for enabling strict contextual
escaping.</p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        type
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>The kind of context in which this value is safe for use.  e.g. url,
  resourceUrl, html, js and css.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value that that should be considered trusted/safe.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>A value that can be used to stand in for the provided <code>value</code> in places
where Angular expects a $sce.trustAs() return value.</p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="trustAsHtml">
    <h3><p><code>trustAsHtml(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.trustAsHtml(value)</code> →
    <a href="api/ng/service/$sceDelegate#trustAs"><code>$sceDelegate.trustAs($sce.HTML, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to trustAs.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>An object that can be passed to <a href="api/ng/service/$sce#getTrustedHtml">$sce.getTrustedHtml(value)</a> to obtain the original value.  (privileged directives
    only accept expressions that are either literal constants or are the
    return value of <a href="api/ng/service/$sce#trustAs">$sce.trustAs</a>.)</p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="trustAsUrl">
    <h3><p><code>trustAsUrl(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.trustAsUrl(value)</code> →
    <a href="api/ng/service/$sceDelegate#trustAs"><code>$sceDelegate.trustAs($sce.URL, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to trustAs.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>An object that can be passed to <a href="api/ng/service/$sce#getTrustedUrl">$sce.getTrustedUrl(value)</a> to obtain the original value.  (privileged directives
    only accept expressions that are either literal constants or are the
    return value of <a href="api/ng/service/$sce#trustAs">$sce.trustAs</a>.)</p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="trustAsResourceUrl">
    <h3><p><code>trustAsResourceUrl(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.trustAsResourceUrl(value)</code> →
    <a href="api/ng/service/$sceDelegate#trustAs"><code>$sceDelegate.trustAs($sce.RESOURCE_URL, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to trustAs.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>An object that can be passed to <a href="api/ng/service/$sce#getTrustedResourceUrl">$sce.getTrustedResourceUrl(value)</a> to obtain the original value.  (privileged directives
    only accept expressions that are either literal constants or are the return
    value of <a href="api/ng/service/$sce#trustAs">$sce.trustAs</a>.)</p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="trustAsJs">
    <h3><p><code>trustAsJs(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.trustAsJs(value)</code> →
    <a href="api/ng/service/$sceDelegate#trustAs"><code>$sceDelegate.trustAs($sce.JS, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to trustAs.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>An object that can be passed to <a href="api/ng/service/$sce#getTrustedJs">$sce.getTrustedJs(value)</a> to obtain the original value.  (privileged directives
    only accept expressions that are either literal constants or are the
    return value of <a href="api/ng/service/$sce#trustAs">$sce.trustAs</a>.)</p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="getTrusted">
    <h3><p><code>getTrusted(type, maybeTrusted);</code></p>

</h3>
    <div><p>Delegates to <a href="api/ng/service/$sceDelegate#getTrusted"><code>$sceDelegate.getTrusted</code></a>.  As such,
takes the result of a <a href="api/ng/service/$sce#trustAs"><code>$sce.trustAs</code></a>() call and returns the
originally supplied value if the queried context type is a supertype of the created type.
If this condition isn&#39;t satisfied, throws an exception.</p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        type
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>The kind of context in which this value is to be used.</p>

        
      </td>
    </tr>
    
    <tr>
      <td>
        maybeTrusted
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The result of a prior <a href="api/ng/service/$sce#trustAs"><code>$sce.trustAs</code></a>
                        call.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>The value the was originally provided to
             <a href="api/ng/service/$sce#trustAs"><code>$sce.trustAs</code></a> if valid in this context.
             Otherwise, throws an exception.</p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="getTrustedHtml">
    <h3><p><code>getTrustedHtml(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.getTrustedHtml(value)</code> →
    <a href="api/ng/service/$sceDelegate#getTrusted"><code>$sceDelegate.getTrusted($sce.HTML, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to pass to <code>$sce.getTrusted</code>.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>The return value of <code>$sce.getTrusted($sce.HTML, value)</code></p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="getTrustedCss">
    <h3><p><code>getTrustedCss(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.getTrustedCss(value)</code> →
    <a href="api/ng/service/$sceDelegate#getTrusted"><code>$sceDelegate.getTrusted($sce.CSS, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to pass to <code>$sce.getTrusted</code>.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>The return value of <code>$sce.getTrusted($sce.CSS, value)</code></p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="getTrustedUrl">
    <h3><p><code>getTrustedUrl(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.getTrustedUrl(value)</code> →
    <a href="api/ng/service/$sceDelegate#getTrusted"><code>$sceDelegate.getTrusted($sce.URL, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to pass to <code>$sce.getTrusted</code>.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>The return value of <code>$sce.getTrusted($sce.URL, value)</code></p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="getTrustedResourceUrl">
    <h3><p><code>getTrustedResourceUrl(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.getTrustedResourceUrl(value)</code> →
    <a href="api/ng/service/$sceDelegate#getTrusted"><code>$sceDelegate.getTrusted($sce.RESOURCE_URL, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to pass to <code>$sceDelegate.getTrusted</code>.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>The return value of <code>$sce.getTrusted($sce.RESOURCE_URL, value)</code></p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="getTrustedJs">
    <h3><p><code>getTrustedJs(value);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.getTrustedJs(value)</code> →
    <a href="api/ng/service/$sceDelegate#getTrusted"><code>$sceDelegate.getTrusted($sce.JS, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        value
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-object">*</a>
      </td>
      <td>
        <p>The value to pass to <code>$sce.getTrusted</code>.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-object">*</a></td>
    <td><p>The return value of <code>$sce.getTrusted($sce.JS, value)</code></p>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="parseAsHtml">
    <h3><p><code>parseAsHtml(expression);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.parseAsHtml(expression string)</code> →
    <a href="api/ng/service/$sce#parseAs"><code>$sce.parseAs($sce.HTML, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        expression
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>String expression to compile.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-function">function(context, locals)</a></td>
    <td><p>a function which represents the compiled expression:</p>
<ul>
<li><code>context</code> – <code>{object}</code> – an object against which any expressions embedded in the strings
are evaluated against (typically a scope object).</li>
<li><code>locals</code> – <code>{object=}</code> – local variables context object, useful for overriding values in
<code>context</code>.</li>
</ul>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="parseAsCss">
    <h3><p><code>parseAsCss(expression);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.parseAsCss(value)</code> →
    <a href="api/ng/service/$sce#parseAs"><code>$sce.parseAs($sce.CSS, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        expression
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>String expression to compile.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-function">function(context, locals)</a></td>
    <td><p>a function which represents the compiled expression:</p>
<ul>
<li><code>context</code> – <code>{object}</code> – an object against which any expressions embedded in the strings
are evaluated against (typically a scope object).</li>
<li><code>locals</code> – <code>{object=}</code> – local variables context object, useful for overriding values in
<code>context</code>.</li>
</ul>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="parseAsUrl">
    <h3><p><code>parseAsUrl(expression);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.parseAsUrl(value)</code> →
    <a href="api/ng/service/$sce#parseAs"><code>$sce.parseAs($sce.URL, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        expression
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>String expression to compile.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-function">function(context, locals)</a></td>
    <td><p>a function which represents the compiled expression:</p>
<ul>
<li><code>context</code> – <code>{object}</code> – an object against which any expressions embedded in the strings
are evaluated against (typically a scope object).</li>
<li><code>locals</code> – <code>{object=}</code> – local variables context object, useful for overriding values in
<code>context</code>.</li>
</ul>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="parseAsResourceUrl">
    <h3><p><code>parseAsResourceUrl(expression);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.parseAsResourceUrl(value)</code> →
    <a href="api/ng/service/$sce#parseAs"><code>$sce.parseAs($sce.RESOURCE_URL, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        expression
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>String expression to compile.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-function">function(context, locals)</a></td>
    <td><p>a function which represents the compiled expression:</p>
<ul>
<li><code>context</code> – <code>{object}</code> – an object against which any expressions embedded in the strings
are evaluated against (typically a scope object).</li>
<li><code>locals</code> – <code>{object=}</code> – local variables context object, useful for overriding values in
<code>context</code>.</li>
</ul>
</td>
  </tr>
</table>
    

  </li>
  
  <li id="parseAsJs">
    <h3><p><code>parseAsJs(expression);</code></p>

</h3>
    <div><p>Shorthand method.  <code>$sce.parseAsJs(value)</code> →
    <a href="api/ng/service/$sce#parseAs"><code>$sce.parseAs($sce.JS, value)</code></a></p>
</div>

    
    <h4>Parameters</h4>
    
<table class="variables-matrix input-arguments">
  <thead>
    <tr>
      <th>Param</th>
      <th>Type</th>
      <th>Details</th>
    </tr>
  </thead>
  <tbody>
    
    <tr>
      <td>
        expression
        
        
      </td>
      <td>
        <a href="" class="label type-hint type-hint-string">string</a>
      </td>
      <td>
        <p>String expression to compile.</p>

        
      </td>
    </tr>
    
  </tbody>
</table>

    

    
    
    
    <h4>Returns</h4>
    <table class="variables-matrix return-arguments">
  <tr>
    <td><a href="" class="label type-hint type-hint-function">function(context, locals)</a></td>
    <td><p>a function which represents the compiled expression:</p>
<ul>
<li><code>context</code> – <code>{object}</code> – an object against which any expressions embedded in the strings
are evaluated against (typically a scope object).</li>
<li><code>locals</code> – <code>{object=}</code> – local variables context object, useful for overriding values in
<code>context</code>.</li>
</ul>
</td>
  </tr>
</table>
    

  </li>
  </ul>
  
  



  
</div>


